Subject: bug#62720: 29.0.60; Not easy at all to upgrade :core packages like Eglot

From: Eli Zaretskii <[email-masked]>
Date: Sat, 22 Apr 2023 15:24:10 +0300

> Date: Sat, 22 Apr 2023 15:14:01 +0300
> Cc: [email-masked], [email-masked], [email-masked],
>  [email-masked], [email-masked], [email-masked]
> From: Dmitry Gutov <[email-masked]>
> 
> On 22/04/2023 15:00, Eli Zaretskii wrote:
> >> Also think forward to Emacs 30: I think the most reasonable choice would
> >> be to have package-update upgrade builtins by default, whereas
> >> package-update-all and package-menu-mark-for-upgrades probably still
> >> need to be preffed off (not sure, but we won't be able to make the
> >> choice until later, I think).
> > I don't see why package-update and package-update-all should behave
> > differently wrt core packages.  If the user expresses his/her will to
> > update core packages, then package-update-all should do this for all
> > of them.
> 
> The idea is that if the user invokes 'M-x package-update' interactively 
> and inputs the name of the package, they express their intention to 
> update said package this way. Whether it's core or not.
> 
> With package-update-all or package-menu-mark-for-update, the user does 
> not have a chance to specify which of the core packages they want to 
> upgrade, if any.

That's why we should have both the prefix-arg and the user option: one
is for one-off update of a single package, the other for updating many
of them.  It's the same logic as for package-install in those cases.